import simple.*;
import java.io.*;	

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents example of simple.
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class Simple
{
	public static Program primesExample(int arraySize)
	{
		Identifier primes = new Identifier("primes");
		Identifier i = new Identifier("i");
		Identifier j = new Identifier("j");
		Identifier startValue = new Identifier("startValue");
		Identifier step = new Identifier("step");
		Identifier prime = new Identifier("prime");
		Identifier mean = new Identifier("mean");
		Identifier sum = new Identifier("sum");
		Identifier isPrime = new Identifier("isPrime");
		
		return
		new Program(
			new BlockDeclaration(
				new DeclarationSequence(
					new DeclarationScalar(sum),
					new DeclarationSequence(
						new DeclarationScalar(mean),
						new DeclarationSequence(
							new DeclarationScalar(i),
							new DeclarationArray(
								primes,
								new Numeral(String.valueOf(arraySize))
							)
						)
					)
				),
				new CommandSequence(
					new CommandBlock(
						new BlockDeclaration(
							new DeclarationSequence(
								new DeclarationConstant(
									startValue,
									new Numeral("3")
								),
								new DeclarationSequence(
									new DeclarationConstant(
										step,
										new Numeral("2")
									),
									new DeclarationScalar(prime)
								)
							),
							new CommandSequence(
								new CommandScalarAssign(
									prime,
									new ExpressionScalarIdentifier(startValue)
								),
								new CommandSequence(
									new CommandScalarAssign(
										i,
										new ExpressionNumeral(new Numeral("2"))
									),
									new CommandSequence(
										new CommandArrayAssign(
											primes,
											new ExpressionNumeral(new Numeral("1")),
											new ExpressionNumeral(new Numeral("2"))
										),
										new CommandWhile(
											new BooleanExprLessEqualThan(
												new ExpressionScalarIdentifier(i),
												new ExpressionArrayLength(primes)
											),
											new BlockDeclaration(
												new DeclarationSequence(
													new DeclarationScalar(j),
													new DeclarationScalar(isPrime)
												),
												new CommandSequence(
													new CommandScalarAssign(
														j,
														new ExpressionNumeral(new Numeral("1"))
													),
													new CommandSequence(
														new CommandScalarAssign(
															isPrime,
															new ExpressionScalarIdentifier(j)
														),
														new CommandSequence(
															new CommandWhile(
																new BooleanExprAnd(
																	new BooleanExprEqual(
																		new ExpressionScalarIdentifier(isPrime),
																		new ExpressionNumeral(new Numeral("1"))
																	),
																	new BooleanExprLessThan(
																		new ExpressionScalarIdentifier(j),
																		new ExpressionScalarIdentifier(i)
																	)
																),
																new BlockCommand(
																	new CommandIfElse(
																		new BooleanExprEqual(
																			new ExpressionModulo(
																				new ExpressionScalarIdentifier(prime),
																				new ExpressionArrayIdentifier(
																					primes,
																					new ExpressionScalarIdentifier(j)
																				)
																			),
																			new ExpressionNumeral(new Numeral("0"))
																		),
																		new BlockCommand(
																			new CommandScalarAssign(
																				isPrime,
																				new ExpressionNumeral(new Numeral("0"))
																			)
																		),
																		new BlockCommand(
																			new CommandScalarAssign(
																				j,
																				new ExpressionMinus(
																					new ExpressionScalarIdentifier(j),
																					new ExpressionNegate(
																						new ExpressionNumeral(new Numeral("1"))
																					)
																				)
																			)
																		)
																	)
																)		
															),
															new CommandSequence(
																new CommandIf(
																	new BooleanExprEqual(
																		new ExpressionScalarIdentifier(isPrime),
																		new ExpressionNumeral(new Numeral("1"))
																	),
																	new BlockDeclaration(
																		new DeclarationConstant(
																			step,
																			new Numeral("1")
																		),
																		new CommandSequence(
																			new CommandScalarAssign(
																				i,
																				new ExpressionPlus(
																					new ExpressionScalarIdentifier(i),
																					new ExpressionScalarIdentifier(step)
																				)
																			),
																			new CommandArrayAssign(
																				primes,
																				new ExpressionMinus(
																					new ExpressionScalarIdentifier(i),
																					new ExpressionScalarIdentifier(step)
																				),
																				new ExpressionScalarIdentifier(prime)
																			)
																		)
																	)
																),
																new CommandScalarAssign(
																	prime,
																	new ExpressionPlus(
																		new ExpressionScalarIdentifier(prime),
																		new ExpressionScalarIdentifier(step)
																	)
																)
															)
														)
													)
												)
											)
										)
									)
								)
							)
						)
					),
					new CommandBlock(
						new BlockDeclaration(
							new DeclarationScalar(j),
							new CommandSequence(
								new CommandScalarAssign(
									sum,
									new ExpressionNumeral(new Numeral("0"))
								),
								new CommandSequence(
									new CommandScalarAssign(
										j,
										new ExpressionNumeral(new Numeral("0"))
									),
									new CommandSequence(
										new CommandWhile(
											new BooleanExprGreaterThan(
												new ExpressionScalarIdentifier(i),
												new ExpressionNumeral(new Numeral("1"))
											),
											new BlockCommand(
												new CommandSequence(
													new CommandScalarAssign(
														i,
														new ExpressionMinus(
															new ExpressionScalarIdentifier(i),
															new ExpressionNumeral(new Numeral("1"))
														)
													),
													new CommandSequence(
														new CommandScalarAssign(
															sum,
															new ExpressionPlus(
																new ExpressionScalarIdentifier(sum),
																new ExpressionArrayIdentifier(
																	primes,
																	new ExpressionScalarIdentifier(i)
																)
															)
														),
														new CommandScalarAssign(
															j,
															new ExpressionPlus(
																new ExpressionScalarIdentifier(j),
																new ExpressionNumeral(new Numeral("1"))
															)
														)
													)
												)
											)
										),
										new CommandScalarAssign(
											mean,
											new ExpressionDividedBy(
												new ExpressionScalarIdentifier(sum),
												new ExpressionScalarIdentifier(j)
											)
										)
									)
								)
							)
						)
					)
				)
			)
		);
	}

	public static void main(String[] arguments)
	{
		Interpreter interpreter = new Interpreter();
		Store store = Store.empty();
		Poststore pstore = null;
		Program prg = null;
		PrintWriter out = new PrintWriter(System.out, true);

    prg = primesExample(5);
		out.println("Program: calculates first 5 primes and their sum and (integer) mean");

		prg.intendPrint(System.out, "");

		out.println("\nStore update history before execution:");
    out.println(store.toString());

		out.println("\nExecution...");
		pstore = interpreter.execute(prg, store);

    out.println("\nStore update history after execution (last updates are listed first):");
    out.println(pstore.toString());
    out.println("\nCurrent store content:");
		out.println(pstore.contentPrint());

    prg = primesExample(2);
		out.println("\nSame program now calculates first 2 primes, operating on old store");

		out.println("\nExecution...");
		pstore = interpreter.execute(prg, pstore);

    out.println("\nStore update history after execution (last updates are listed first):");
    out.println(pstore.toString());
    out.println("\nCurrent store content:");
		out.println(pstore.contentPrint());

		prg = primesExample(20);
		out.println("\nSame program now calculates first 20 primes, operating on old store");

		out.println("\nExecution...");
		pstore = interpreter.execute(prg, pstore);

    out.println("\nCurrent store content:");
		out.println(pstore.contentPrint());
	}
}