package simple;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Array.
 *	Domain Array maps positive integers to referenceable-values
 *	limited by upper boundary value.
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class Array extends Domain
{
	Function map = null;
	Num upper = null;
	
	public static Array empty(Num upper)
	{
		return new Array(ReferenceableValue.inErrvalue(), upper);
	}
	
	public Array augment(Num n, ReferenceableValue rval)
	{
		return new Array(map.update(n, rval), upper);
	}
	
	public ReferenceableValue access(Num n)
	{
		Tr tr = n.lessEqualThan(upper).and(n.greaterThan(Num.ZERO()));
		
		if (tr.isTrue() != null)
		{
			return (ReferenceableValue)map.access(n);
		}
		else
		if (tr.isFalse() != null)
		{
			return ReferenceableValue.inErrvalue();
		}
		return null;
	}
	
	public Num length()
	{
		return upper;
	}
	
	protected Array(ReferenceableValue defaultValue, Num upper)
	{
		map = new Function(defaultValue);
		this.upper = upper;
	}
	
	protected Array(Function map, Num upper)
	{
		this.map = map;
		this.upper = upper;
	}
}