package simple;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Boolean-expr-value.
 *	Domain Boolean-expr-value represents values,
 *	that can be results of boolean expression evaluation.
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class BooleanExprValue extends Domain
{
	Domain value = Errvalue.ERRVALUE();
	
	public static BooleanExprValue inTr(Tr tr)
	{
		return new BooleanExprValue(tr);
	}
	
	public static BooleanExprValue inErrvalue()
	{
		return new BooleanExprValue(Errvalue.ERRVALUE());
	}
	
	public String toString()
	{
		return "(Boolean-expr-value: " + value.toString() + ")";
	}
	
	public Tr isTr()
	{
		if (value instanceof Tr)
		{
			return (Tr)value;
		}
		else
		{
			return null;
		}
	}

	public Errvalue isErrvalue()
	{
		if (value instanceof Errvalue)
		{
			return (Errvalue)value;
		}
		else
		{
			return null;
		}
	}
	
	protected BooleanExprValue(Domain value)
	{
		this.value = value;
	}
}