package simple;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Denotable-value.
 *	Domain Denotable-value represents values
 *	that can be denoted by identifiers.
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class DenotableValue extends Domain
{
	/** Holds denoted value */
	Domain value = Errvalue.ERRVALUE();
	
	public static DenotableValue inLocation(Location loc)
	{
		return new DenotableValue(loc);
	}
	
	public static DenotableValue inConstantValue(ConstantValue cval)
	{
		return new DenotableValue(cval);
	}
		
	public static DenotableValue inArray(Array arr)
	{
		return new DenotableValue(arr);
	}
	
	public static DenotableValue inErrvalue()
	{
		return new DenotableValue(Errvalue.ERRVALUE());
	}
	
	public String toString()
	{
		return "(Denotable-value: " + value.toString() + ")";
	}
	
	public Location isLocation()
	{
		if (value instanceof Location)
		{
			return (Location)value;
		}
		else
		{
			return null;
		}
	}
	
	public ConstantValue isConstantValue()
	{
		if (value instanceof ConstantValue)
		{
			return (ConstantValue)value;
		}
		else
		{
			return null;
		}
	}
	
	public Array isArray()
	{
		if (value instanceof Array)
		{
			return (Array)value;
		}
		else
		{
			return null;
		}
	}
	
	public Errvalue isErrvalue()
	{
		if (value instanceof Errvalue)
		{
			return (Errvalue)value;
		}
		else
		{
			return null;
		}
	}
	
	protected DenotableValue(Domain value)
	{
		this.value = value;
	}
}