package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Poststore.
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class Poststore extends Domain
{
	/** Holds store */
	Store store = null;
	boolean ok = true;
	
	public static Poststore inOk(Store store)
	{
		return new Poststore(true, store);
	}
	
	public static Poststore inErr(Store store)
	{
		return new Poststore(false, store);
	}
	
	public Store isOk()
	{
		if (ok) /* instance of cannot be used obviously */
		{
			return store;
		}
		else
		{
			return null;
		}
	}

	public Store isErr()
	{
		if (ok)
		{
			return null;
		}
		else
		{
			return store;
		}
	}

  public String contentPrint()
	{
		Store s = null;

		if ((s = isOk()) != null)
		{
			return "(Poststore: Ok:\n" + s.contentPrint() + ")";
		}
		else
		if ((s = isErr()) != null)
		{
			return "(Poststore: Err:\n" + s.contentPrint() + ")";
		}
		return "(Poststore: null)";
	}

	public String toString()
	{
		Store s = null;

		if ((s = isOk()) != null)
		{
			return "(Poststore: Ok:\n" + s.toString() + ")";
		}
		else
		if ((s = isErr()) != null)
		{
			return "(Poststore: Err:\n" + s.toString() + ")";
		}
		return "(Poststore: null)";
	}

	protected Poststore(boolean ok, Store store)
	{
		this.ok = ok;
		this.store = store;
	}
}