package simple;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Tr.
 *	Domain Truth represents boolean values.
 *
 *	The selection operation Tr --> _ [] _ must
 *	be implemented using if. A function of Tr
 *	taking the two possible options would require the
 *	evaluation of the two parameters.
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class Tr extends Domain
{
	Unit value = null;
	
	public static Tr TRUE()
	{
		return inTrue();
	}
	
	public static Tr FALSE()
	{
		return inFalse();
	}
	
	public static Tr inTrue()
	{
		return new Tr(True.TRUE());
	}
	
	public static Tr inFalse()
	{
		return new Tr(False.FALSE());
	}
	
	public String toString()
	{
		return "(Tr: " + value.toString() + ")";
	}
	
	public Tr not()
	{
		if (isTrue() != null)
		{
			return FALSE();
		}
		else
		{
			return TRUE();
		}
	}
	
	public Tr and(Tr tr)
	{
		if (isTrue() != null)
		{
			return tr;
		}
		else
		{
			return FALSE();
		}
	}
	
	public Tr or(Tr tr)
	{
		if (isTrue() != null)
		{
			return TRUE();
		}
		else
		{
			return tr;
		}
	}
	
	public True isTrue()
	{
		if (value instanceof True)
		{
			return (True)value;
		}
		else
		{
			return null;
		}
	}

	public False isFalse()
	{
		if (value instanceof False)
		{
			return (False)value;
		}
		else
		{
			return null;
		}
	}
	
	protected Tr(Unit value)
	{
		this.value = value;
	}
}