package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain And-boolean-expr.
 *	B ::= B1 and B2
 *
 *	The implementation of and uses short-circuit evaluation.
 *	(as example).
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class BooleanExprAnd extends BooleanExpr
{
	BooleanExpr bexp1 = null;
	BooleanExpr bexp2 = null;

	public String toString()
	{
		return "(BooleanExprAnd: " + bexp1.toString() + ", " + bexp2.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("(");
		bexp1.intendPrint(out, intend);
		out.print(" and ");
		bexp2.intendPrint(out, intend);
		out.print(")");
	}
	
	BooleanExprValue execute(Environment e, Store s)
	{
		BooleanExprValue bval1 = bexp1.execute(e, s);
		Tr tr1 = null;
		Errvalue err = null;
		
		if ((tr1 = bval1.isTr()) != null)
		{
			if (tr1.isTrue() != null)
			{
				return bexp2.execute(e, s);
			}
			else
			if (tr1.isFalse() != null)
			{
				return BooleanExprValue.inTr(Tr.FALSE());
			}
		}
		else
		if ((err = bval1.isErrvalue()) != null)
		{
			return BooleanExprValue.inErrvalue();
		}
		return null;
	}
	
	public BooleanExprAnd(BooleanExpr bexp1, BooleanExpr bexp2)
	{
		this.bexp1 = bexp1;
		this.bexp2 = bexp2;
	}
}