package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Not-boolean-expr.
 *	B ::= not B2
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class BooleanExprNot extends BooleanExpr
{
	BooleanExpr bexp = null;
	
	public String toString()
	{
		return "(BooleanExprNot: " + bexp.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("not ");
		bexp.intendPrint(out, intend);
	}
	
	BooleanExprValue execute(Environment e, Store s)
	{
		BooleanExprValue bval = bexp.execute(e, s);
		Tr tr = null;
		Errvalue err = null;
		
		if ((tr = bval.isTr()) != null)
		{
			return BooleanExprValue.inTr(tr.not());
		}
		else
		if ((err = bval.isErrvalue()) != null)
		{
			return BooleanExprValue.inErrvalue();
		}
		return null;
	}
	
	public BooleanExprNot(BooleanExpr bexp)
	{
		this.bexp = bexp;
	}
}