package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents syntax domain If-Command.
 *	C ::= if B then K
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class CommandIf extends Command
{
	BooleanExpr bexp = null;
	Block block = null;
	
	public String toString()
	{
		return "(CommandIf: " + bexp.toString() + ", " + block.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("\n" + intend + "if ");
		bexp.intendPrint(out, intend);
		out.print(" then");
		block.intendPrint(out, intend);
	}

	Poststore execute(Environment e, Store s)
	{
		BooleanExprValue bval = bexp.execute(e, s);
		Tr tr = null;
		Errvalue err = null;
		
		if ((tr = bval.isTr()) != null)
		{
			if (tr.isTrue() != null)
			{
				return block.execute(e, s);
			}
			else
			if (tr.isFalse() != null)
			{
				return Poststore.inOk(s);
			}
		}
		else
		if ((err = bval.isErrvalue()) != null)
		{
			return Poststore.inErr(s);
		}
		return null;
	}

	public CommandIf(BooleanExpr bexp, Block block)
	{
		this.bexp = bexp;
		this.block = block;
	}
}