package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents syntax domain IfElse-Command.
 *	C ::= if B then K1 else K2
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class CommandIfElse extends Command
{
	BooleanExpr bexp = null;
	Block blockThen = null;
	Block blockElse = null;
	
	public String toString()
	{
		return "(CommandIfElse: " + bexp.toString() + ", " + blockThen.toString() + ", " + blockElse.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("\n" + intend + "if ");
		bexp.intendPrint(out, intend);
		out.print(" then");
		blockThen.intendPrint(out, intend);
		out.print("\n" + intend + "else");
		blockElse.intendPrint(out, intend);
	}

	Poststore execute(Environment e, Store s)
	{
		BooleanExprValue bval = bexp.execute(e, s);
		Tr tr = null;
		Errvalue err = null;
		
		if ((tr = bval.isTr()) != null)
		{
			if (tr.isTrue() != null)
			{
				return blockThen.execute(e, s);
			}
			else
			if (tr.isFalse() != null)
			{
				return blockElse.execute(e, s);
			}
		}
		else
		if ((err = bval.isErrvalue()) != null)
		{
			return Poststore.inErr(s);
		}
		return null;
	}

	public CommandIfElse(BooleanExpr bexp, Block blockThen, Block blockElse)
	{
		this.bexp = bexp;
		this.blockThen = blockThen;
		this.blockElse = blockElse;
	}
}