package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents syntax domain ScalarAssign-Command.
 *	C ::= I := E
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class CommandScalarAssign extends Command
{
	Identifier ident = null;
	Expression exp = null;
	
	public String toString()
	{
		return "(CommandScalarAssign: " + ident.toString() + ", " + exp.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("\n" + intend);
		ident.intendPrint(out, intend);
		out.print(" := ");
		exp.intendPrint(out, intend);
	}
	
	Poststore execute(Environment e, Store s)
	{
		DenotableValue dval = e.access(ident.execute());
		Location l = null;
		Errvalue err = null;
		Array arr = null;
		ConstantValue cval = null;
		
		if ((l = dval.isLocation()) != null)
		{
			ExpressibleValue xval = exp.execute(e, s);
			Num n = null;
			if ((n = xval.isNum()) != null)
			{
				return s.update(l, new StorableValue(n)); // conversion needed
			}
			else
			if ((err = xval.isErrvalue()) != null)
			{
				return Poststore.inErr(s);
			}
		}
		else
		if ((arr = dval.isArray()) != null)
		{
			return Poststore.inErr(s);
		}
		else
		if ((cval = dval.isConstantValue()) != null)
		{
			return Poststore.inErr(s);
		}
		if ((err = dval.isErrvalue()) != null)
		{
			return Poststore.inErr(s);
		}
		return null;
	}

	public CommandScalarAssign(Identifier ident, Expression exp)
	{
		this.ident = ident;
		this.exp = exp;
	}
}