package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Command-Sequence.
 *	C ::= C1; C2
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class CommandSequence extends Command
{
	Command cmd1 = null;
	Command cmd2 = null;
	
	public String toString()
	{
		return "(CommandSequence: " + cmd1.toString() + ", " + cmd2.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		cmd1.intendPrint(out, intend);
		out.print(";");
		cmd2.intendPrint(out, intend);
	}

	Poststore execute(Environment e, Store s)
	{
		Poststore p = cmd1.execute(e, s);
		Store s1 = null;
		
		if ((s1 = p.isOk()) != null)
		{
			return cmd2.execute(e, s1);
		}
		else
		if ((s1 = p.isErr()) != null)
		{
			return Poststore.inErr(s1);
		}
		return null;
	}
	
	public CommandSequence(Command cmd1, Command cmd2)
	{
		this.cmd1 = cmd1;
		this.cmd2 = cmd2;
	}
}