package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Declaration of Constant.
 *	D ::= const I = N
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class DeclarationConstant extends Declaration
{
	Identifier ident = null;
	Numeral value = null;

	public String toString()
	{
		return "(DeclarationConstant: " + ident.toString() + ", " + value.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		out.print("\n" + intend + "const ");
		ident.intendPrint(out, intend);
		out.print(" = ");
		value.intendPrint(out, intend);
	}
	
	DeclarationResult execute(Environment e, Store s)
	{
		return new DeclarationResult(
			e.update(ident.execute(), DenotableValue.inConstantValue(new ConstantValue(value.execute()))), Poststore.inOk(s));
	}
	
	public DeclarationConstant(Identifier ident, Numeral value)
	{
		this.ident = ident;
		this.value = value;
	}
}