package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Declaration-Sequence.
 *	D ::= D1; D2
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class DeclarationSequence extends Declaration
{
	Declaration decl1 = null;
	Declaration decl2 = null;

	public String toString()
	{
		return "(DeclarationSequence: " + decl1.toString() + ", " + decl2.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		decl1.intendPrint(out, intend);
		out.print(";");
		decl2.intendPrint(out, intend);
	}
	
	DeclarationResult execute(Environment e, Store s)
	{
		DeclarationResult declRes = decl1.execute(e, s);
		Store s1 = null;
		
		if ((s1 = declRes.p.isOk()) != null)
		{
			return decl2.execute(declRes.e, s1);
		}
		else
		if ((s1 = declRes.p.isErr()) != null)
		{
			return new DeclarationResult(declRes.e, Poststore.inErr(s1));
		}
		return null;
	}
	
	public DeclarationSequence(Declaration decl1, Declaration decl2)
	{
		this.decl1 = decl1;
		this.decl2 = decl2;
	}
}