package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Array-length-expression.
 *	E ::= I.length
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class ExpressionArrayLength extends Expression
{
	Identifier ident = null;
	
	public String toString()
	{
		return "(ExpressionArrayLength: " + ident.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		ident.intendPrint(out, intend);
		out.print(".length");
	}
	
	ExpressibleValue execute(Environment e, Store s)
	{
		DenotableValue dval = e.access(ident.execute());
		Location l = null;
		ConstantValue cval = null;
		Array arr = null;
		Errvalue err = null;
		
		if ((l = dval.isLocation()) != null)
		{
			return ExpressibleValue.inErrvalue();
		}
		else
		if ((cval = dval.isConstantValue()) != null)
		{
			return ExpressibleValue.inErrvalue();
		}
		else
		if ((arr = dval.isArray()) != null)
		{
			return ExpressibleValue.inNum(arr.length());
		}
		else
		if ((err = dval.isErrvalue()) != null)
		{
			return ExpressibleValue.inErrvalue();
		}
		return null;
	}
	
	public ExpressionArrayLength(Identifier ident)
	{
		this.ident = ident;
	}
}