package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents domain Scalar-identifier-expression.
 *	E ::= I
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class ExpressionScalarIdentifier extends Expression
{
	Identifier ident = null;

	public String toString()
	{
		return "(ExpressionScalarIdentifier: " + ident.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		ident.intendPrint(out, intend);
	}
	
	ExpressibleValue execute(Environment e, Store s)
	{
		DenotableValue dval = e.access(ident.execute());
		Location l = null;
		ConstantValue cval = null;
		Array arr = null;
		Errvalue err = null;
		
		if ((l = dval.isLocation()) != null)
		{
			StoreaccessValue aval = s.access(l);
			StorableValue sval = null;
			
			if ((sval = aval.isStorableValue()) != null)
			{
				return ExpressibleValue.inNum(new Num(sval)); // conversion needed
			}
			else
			if ((err = aval.isErrvalue()) != null)
			{
				return ExpressibleValue.inErrvalue();
			}
		}
		else
		if ((cval = dval.isConstantValue()) != null)
		{
			return ExpressibleValue.inNum(new Num(cval));
		}
		else
		if ((arr = dval.isArray()) != null)
		{
			return ExpressibleValue.inErrvalue();
		}
		else
		if ((err = dval.isErrvalue()) != null)
		{
			return ExpressibleValue.inErrvalue();
		}
		return null;
	}
	
	public ExpressionScalarIdentifier(Identifier ident)
	{
		this.ident = ident;
	}
}