package simple;

import java.io.*;

/**
 *	Formal Semantics of Programming Languages
 *	SS 99
 *	1. Exercise
 *
 *	Class represents syntax domain Program.
 *	P ::= K.
 *
 *	@author Jrgen Hartl, 9756179 / 881
 *	@version 1.0 (JDK 1.1.7)
 */
public class Program extends SyntaxDomain
{
	Block block = null;
	
	public String toString()
	{
		return "(Program: " + block.toString() + ")";
	}
	
	public void intendPrint(PrintStream out, String intend)
	{
		block.intendPrint(out, intend + INTENDSTEP);
		out.println(".");
	}
	
	public Poststore execute(Store s)
	{
		return block.execute(Environment.empty(), s);
	}
	
	public Program(Block block)
	{
		this.block = block;
	}
}